"""J.A.R.V.I.S. guild event handler."""
import asyncio

from discord import Guild
from discord.ext.commands import Bot
from discord.utils import find

from jarvis.db.models import Setting


class GuildEventHandler(object):
    """J.A.R.V.I.S. guild event handler."""

    def __init__(self, bot: Bot):
        self.bot = bot
        self.bot.add_listener(self.on_guild_join)

    async def on_guild_join(self, guild: Guild) -> None:
        """Handle on_guild_join event."""
        general = find(lambda x: x.name == "general", guild.channels)
        if general and general.permissions_for(guild.me).send_messages:
            user = self.bot.user
            await general.send(
                f"Allow me to introduce myself. I am {user.mention}, a virtual "
                "artificial intelligence, and I'm here to assist you with a "
                "variety of tasks as best I can, "
                "24 hours a day, seven days a week."
            )
            await asyncio.sleep(1)
            await general.send("Importing all preferences from home interface...")

            # Set some default settings
            _ = Setting(guild=guild.id, setting="massmention", value=5).save()
            _ = Setting(guild=guild.id, setting="noinvite", value=True).save()

            await general.send("Systems are now fully operational")
