"""J.A.R.V.I.S. Member event handler."""
from discord import Member
from discord.ext.commands import Bot

from jarvis.db.models import Mute, Setting


class MemberEventHandler(object):
    """J.A.R.V.I.S. Member event handler."""

    def __init__(self, bot: Bot):
        self.bot = bot
        self.bot.add_listener(self.on_member_join)

    async def on_member_join(self, user: Member) -> None:
        """Handle on_member_join event."""
        guild = user.guild
        mute = Mute.objects(guild=guild.id, user=user.id, active=True).first()
        if mute:
            mute_role = Setting.objects(guild=guild.id, setting="mute").first()
            role = guild.get_role(mute_role.value)
            await user.add_roles(role, reason="User is still muted from prior mute")
        unverified = Setting.objects(guild=guild.id, setting="unverified").first()
        if unverified:
            role = guild.get_role(unverified.value)
            if role not in user.roles:
                await user.add_roles(role, reason="User just joined and is unverified")
